-- By Ashnal
-- You know how many scripts do the wierd "local k_speedboost = k_speedboost" thing?
-- Some other more dynamic globals that many mods rely on for per tic calcs also go through that super long string lookup in hardcode (lib_getenum)
-- Here, I've put all the ones that reasonably do not change during a race into a MapChange hook, so they can be put into
-- the Lua global registry where their lookups will be faster during gameplay

-- This script is why we reccommend loading this addon first

if au_globalizeharder == nil then rawset(_G, "au_globalizeharder", true) else return end

-- Don't turn this on unless you've loaded the addon as the very first addon of your load order, it defaults off since it could desync shit otherwise
local optimizeleveltime = false
local cv_leveltimeoptimize = CV_RegisterVar({
    name = "au_leveltimeoptimize",
    defaultvalue = "Off",
    flags = CV_NETVAR|CV_CALL,
    PossibleValue = CV_OnOff,
	func = function(var)
		if not optimizeleveltime and var.value then
			if server == consoleplayer or not consoleplayer then
				print("This setting cannot be turned off. Restart the game to do so.")
			end
			optimizeleveltime = true
		elseif	not optimizeleveltime and not var.value then -- Either called on load or someone passed in off while it was still off
			-- nothing
		else -- Optimize is already on and can't be turned off
			print("This setting cannot be turned off. Restart the game to do so.")
			COM_BufInsertText(server, "au_leveltimeoptimize on")
		end
	end
})

-- Tyron: That's fuckin illegal

local localleveltime = leveltime
local localmapnum = gamemap

addHook("MapChange", function(mapnum)
	localmapnum = mapnum
	rawset(_G,"gamemap", localmapnum)
	rawset(_G,"server", players[0]) -- actually, the server player is always player slot 0, so no need to use the laggy enum
end)

addHook("MapLoad", function()
	-- I could set a lot of other map header related globals here
	rawset(_G,"mapobjectscale", (mapheaderinfo[gamemap] and mapheaderinfo[gamemap].mobj_scale)) -- Use in any sort of physics and movement code usually, high impact
	rawset(_G,"gamespeed", CV_FindVar("kartspeed").value)
	localleveltime = 0
end)

addHook("NetVars", function(net)
	localleveltime = net($)
	localmapnum = net($)
	-- need to do these here since joiners don't run MapLoad/MapChange -- Holy shit I just realized you can substitute a NetVars hook for Mapload/MapChange specifically for joiners ...
	rawset(_G,"mapobjectscale", (mapheaderinfo[gamemap] and mapheaderinfo[gamemap].mobj_scale))
	rawset(_G,"gamespeed", CV_FindVar("kartspeed").value)
	rawset(_G,"server", players[0])
	rawset(_G,"gamemap", localmapnum)
end)

-- Even more illegal

addHook("MobjThinker", function(mo)
	if optimizeleveltime and localleveltime > leveltime then -- ensures this only gets dont once per frame, despite executing ina  mobjthinker
		rawset(_G,"leveltime", localleveltime) -- Only gonna do this for leveltime since its easy to know what it should be when we cant actually retrieve the value since we overwrote it
		-- Also this could potentially be a little stinky since mods loaded before us might read the leveltime as one tic behind mods that load after us, whic is why we have this non-default
	end
end, MT_PLAYER)

addHook("ThinkFrame", do
	localleveltime = $ + 1 -- Here we increment since ThinkFrame executes after all MobjThinkers
end)