-- By Ashnal
-- Rotates maps periodically whenever the server is empty
-- Depends on kl_randommap_v1.lua

if au_maprotate == nil then rawset (_G, "au_maprotate", true) else return end 

local cv_maprotate = CV_RegisterVar({
    name = "au_maprotate",
    defaultvalue = "On",
    flags = CV_NETVAR, -- Doesnt really matter, but this will let clients know its on
    PossibleValue = CV_OnOff
})

-- From Hostmod, thanks!
local function randommap(p, ...)
	COM_BufAddText(server, "map "..G_BuildMapName(0))
end
COM_AddCommand("randommap", randommap, 1)

local VOTE = 3

local count
local function ActivePlayers()
	for p in players.iterate do
		if not (p and p.valid and not p.spectator) then continue end
		count = $ + 1
	end
	return count
end

addHook("ThinkFrame", do
	if cv_maprotate.value and leveltime > 31500 and not ActivePlayers() then -- If you've been in a map longer than 15 minutes and no players
		if CV_FindVar("advancemap").value == VOTE then -- If set to vote and there are no players, exitlevel will just go to nextmap instead of random when exitlevel is called, so we fix that here
			COM_BufInsertText(server, "randommap")
		else
			COM_BufInsertText(server, "exitlevel")
		end
	end
end)